_read_mlx:
;Magneto_2_PIC32.c,15 :: 		int read_mlx(){
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;Magneto_2_PIC32.c,16 :: 		uint16_t datavalue = 0;
SW	R25, 4(SP)
;Magneto_2_PIC32.c,17 :: 		uint16_t inverted_datavalue = 0;
;Magneto_2_PIC32.c,18 :: 		uint16_t checkvalue = 0;
;Magneto_2_PIC32.c,20 :: 		Chip_Select = 0;
LUI	R2, BitMask(RC2_bit+0)
ORI	R2, R2, BitMask(RC2_bit+0)
_SX	
;Magneto_2_PIC32.c,21 :: 		Delay_us(6);
LUI	R24, 0
ORI	R24, R24, 15
L_read_mlx0:
ADDIU	R24, R24, -1
BNE	R24, R0, L_read_mlx0
NOP	
NOP	
;Magneto_2_PIC32.c,22 :: 		SPI3_Write(0xAA);
ORI	R25, R0, 170
JAL	_SPI3_Write+0
NOP	
;Magneto_2_PIC32.c,23 :: 		SPI3_Write(0xFF);
ORI	R25, R0, 255
JAL	_SPI3_Write+0
NOP	
;Magneto_2_PIC32.c,24 :: 		Delay_us(45);
LUI	R24, 0
ORI	R24, R24, 119
L_read_mlx2:
ADDIU	R24, R24, -1
BNE	R24, R0, L_read_mlx2
NOP	
NOP	
;Magneto_2_PIC32.c,25 :: 		mlx.buffer[3]=SPI3_Read(0xFF);
ORI	R25, R0, 255
JAL	_SPI3_Read+0
NOP	
SB	R2, Offset(_mlx+7)(GP)
;Magneto_2_PIC32.c,26 :: 		mlx.buffer[2]=SPI3_Read(0xFF);
ORI	R25, R0, 255
JAL	_SPI3_Read+0
NOP	
SB	R2, Offset(_mlx+6)(GP)
;Magneto_2_PIC32.c,27 :: 		Delay_us(40);
LUI	R24, 0
ORI	R24, R24, 106
L_read_mlx4:
ADDIU	R24, R24, -1
BNE	R24, R0, L_read_mlx4
NOP	
;Magneto_2_PIC32.c,28 :: 		mlx.buffer[1]=SPI3_Read(0xFF);
ORI	R25, R0, 255
JAL	_SPI3_Read+0
NOP	
SB	R2, Offset(_mlx+5)(GP)
;Magneto_2_PIC32.c,29 :: 		mlx.buffer[0]=SPI3_Read(0xFF);
ORI	R25, R0, 255
JAL	_SPI3_Read+0
NOP	
SB	R2, Offset(_mlx+4)(GP)
;Magneto_2_PIC32.c,31 :: 		Chip_Select = 1;
LUI	R2, BitMask(RC2_bit+0)
ORI	R2, R2, BitMask(RC2_bit+0)
_SX	
;Magneto_2_PIC32.c,34 :: 		datavalue = ((uint16_t) mlx.buffer[3]) << 8;
LBU	R2, Offset(_mlx+7)(GP)
ANDI	R2, R2, 65535
SLL	R3, R2, 8
;Magneto_2_PIC32.c,35 :: 		datavalue |= ((uint16_t) mlx.buffer[2]);
LBU	R2, Offset(_mlx+6)(GP)
OR	R2, R3, R2
; datavalue start address is: 16 (R4)
ANDI	R4, R2, 65535
;Magneto_2_PIC32.c,37 :: 		checkvalue = datavalue & 1;   // LSB signifies an error, check if there is an error in measurement
ANDI	R2, R2, 1
;Magneto_2_PIC32.c,39 :: 		if (checkvalue == 0 )
ANDI	R2, R2, 65535
BEQ	R2, R0, L__read_mlx20
NOP	
J	L_read_mlx6
NOP	
L__read_mlx20:
; datavalue end address is: 16 (R4)
;Magneto_2_PIC32.c,40 :: 		return -1;
ORI	R2, R0, 65535
J	L_end_read_mlx
NOP	
L_read_mlx6:
;Magneto_2_PIC32.c,42 :: 		inverted_datavalue = ((uint16_t) mlx.buffer[1]) << 8;
; datavalue start address is: 16 (R4)
LBU	R2, Offset(_mlx+5)(GP)
ANDI	R2, R2, 65535
SLL	R3, R2, 8
;Magneto_2_PIC32.c,43 :: 		inverted_datavalue |= ((uint16_t) mlx.buffer[0]);
LBU	R2, Offset(_mlx+4)(GP)
OR	R2, R3, R2
;Magneto_2_PIC32.c,46 :: 		if (datavalue != ~inverted_datavalue)
NOR	R2, R2, R0
ANDI	R3, R4, 65535
ANDI	R2, R2, 65535
BNE	R3, R2, L__read_mlx22
NOP	
J	L_read_mlx7
NOP	
L__read_mlx22:
; datavalue end address is: 16 (R4)
;Magneto_2_PIC32.c,47 :: 		return -1;
ORI	R2, R0, 65535
J	L_end_read_mlx
NOP	
L_read_mlx7:
;Magneto_2_PIC32.c,51 :: 		mlx.angle = datavalue >> 2;
; datavalue start address is: 16 (R4)
ANDI	R2, R4, 65535
; datavalue end address is: 16 (R4)
SRL	R2, R2, 2
SH	R2, Offset(_mlx+0)(GP)
;Magneto_2_PIC32.c,52 :: 		return 0;
MOVZ	R2, R0, R0
;Magneto_2_PIC32.c,55 :: 		}
;Magneto_2_PIC32.c,52 :: 		return 0;
;Magneto_2_PIC32.c,55 :: 		}
L_end_read_mlx:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _read_mlx
_main:
;Magneto_2_PIC32.c,58 :: 		void main()
ADDIU	SP, SP, -20
;Magneto_2_PIC32.c,61 :: 		char txt[20]   = { 0 };
ADDIU	R23, SP, 0
ADDIU	R22, R23, 20
LUI	R24, hi_addr(?ICSmain_txt_L0+0)
ORI	R24, R24, lo_addr(?ICSmain_txt_L0+0)
JAL	___CC2DW+0
NOP	
;Magneto_2_PIC32.c,62 :: 		uint8_t check  = 0;
;Magneto_2_PIC32.c,63 :: 		float angle    = 0.0;
;Magneto_2_PIC32.c,65 :: 		CS_DIR = 0;
LUI	R2, BitMask(TRISC2_bit+0)
ORI	R2, R2, BitMask(TRISC2_bit+0)
_SX	
;Magneto_2_PIC32.c,67 :: 		UART2_Init( 9600 );
ORI	R25, R0, 9600
JAL	_UART2_Init+0
NOP	
;Magneto_2_PIC32.c,68 :: 		Delay_ms(300);
LUI	R24, 12
ORI	R24, R24, 13567
L_main9:
ADDIU	R24, R24, -1
BNE	R24, R0, L_main9
NOP	
NOP	
;Magneto_2_PIC32.c,70 :: 		UART2_Write_Text("Uart initialized\r\n");
LUI	R25, hi_addr(?lstr1_Magneto_2_PIC32+0)
ORI	R25, R25, lo_addr(?lstr1_Magneto_2_PIC32+0)
JAL	_UART2_Write_Text+0
NOP	
;Magneto_2_PIC32.c,73 :: 		SPI3_Init_Advanced( _SPI_MASTER, _SPI_8_BIT, 512, _SPI_SS_DISABLE,
MOVZ	R28, R0, R0
ORI	R27, R0, 512
MOVZ	R26, R0, R0
ORI	R25, R0, 32
;Magneto_2_PIC32.c,75 :: 		_SPI_ACTIVE_2_IDLE );
ADDIU	SP, SP, -8
SH	R0, 4(SP)
;Magneto_2_PIC32.c,74 :: 		_SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW,
SH	R0, 2(SP)
SH	R0, 0(SP)
;Magneto_2_PIC32.c,75 :: 		_SPI_ACTIVE_2_IDLE );
JAL	_SPI3_Init_Advanced+0
NOP	
ADDIU	SP, SP, 8
;Magneto_2_PIC32.c,76 :: 		Delay_ms(200);
LUI	R24, 8
ORI	R24, R24, 9044
L_main11:
ADDIU	R24, R24, -1
BNE	R24, R0, L_main11
NOP	
NOP	
NOP	
;Magneto_2_PIC32.c,77 :: 		UART2_Write_Text( "SPI Initialized\r\n" );
LUI	R25, hi_addr(?lstr2_Magneto_2_PIC32+0)
ORI	R25, R25, lo_addr(?lstr2_Magneto_2_PIC32+0)
JAL	_UART2_Write_Text+0
NOP	
;Magneto_2_PIC32.c,80 :: 		while (1)
L_main13:
;Magneto_2_PIC32.c,82 :: 		check = read_mlx();
JAL	_read_mlx+0
NOP	
;Magneto_2_PIC32.c,83 :: 		if ( check == 0)                          // if read was successful, print success and angle
ANDI	R2, R2, 255
BEQ	R2, R0, L__main24
NOP	
J	L_main15
NOP	
L__main24:
;Magneto_2_PIC32.c,85 :: 		UART2_Write_Text("Success \r\n");
LUI	R25, hi_addr(?lstr3_Magneto_2_PIC32+0)
ORI	R25, R25, lo_addr(?lstr3_Magneto_2_PIC32+0)
JAL	_UART2_Write_Text+0
NOP	
;Magneto_2_PIC32.c,86 :: 		angle = (float) mlx.angle;
LHU	R4, Offset(_mlx+0)(GP)
JAL	__Unsigned16IntToFloat+0
NOP	
;Magneto_2_PIC32.c,87 :: 		angle /= 45.5;
LUI	R6, 16950
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
;Magneto_2_PIC32.c,88 :: 		FloatToStr(angle,txt);
ADDIU	R3, SP, 0
MOVZ	R26, R3, R0
MOVZ	R25, R2, R0
JAL	_FloatToStr+0
NOP	
;Magneto_2_PIC32.c,89 :: 		UART2_Write_Text(txt);
ADDIU	R2, SP, 0
MOVZ	R25, R2, R0
JAL	_UART2_Write_Text+0
NOP	
;Magneto_2_PIC32.c,90 :: 		UART2_Write_Text("\r\n");
LUI	R25, hi_addr(?lstr4_Magneto_2_PIC32+0)
ORI	R25, R25, lo_addr(?lstr4_Magneto_2_PIC32+0)
JAL	_UART2_Write_Text+0
NOP	
;Magneto_2_PIC32.c,91 :: 		}
J	L_main16
NOP	
L_main15:
;Magneto_2_PIC32.c,93 :: 		UART2_Write_Text("Fail \r\n");
LUI	R25, hi_addr(?lstr5_Magneto_2_PIC32+0)
ORI	R25, R25, lo_addr(?lstr5_Magneto_2_PIC32+0)
JAL	_UART2_Write_Text+0
NOP	
L_main16:
;Magneto_2_PIC32.c,95 :: 		Delay_ms(400);                // Wait 400ms
LUI	R24, 16
ORI	R24, R24, 18090
L_main17:
ADDIU	R24, R24, -1
BNE	R24, R0, L_main17
NOP	
;Magneto_2_PIC32.c,96 :: 		}
J	L_main13
NOP	
;Magneto_2_PIC32.c,97 :: 		}
L_end_main:
L__main_end_loop:
J	L__main_end_loop
NOP	
; end of _main
